#ifndef __AUDIO_H__
#define __AUDIO_H__

#include "SString.h"
#include "List.h"

#define DEFAULT_MUSIC_FADE_TIME 2.0f

struct _Mix_Music;
struct Mix_Chunk;

class Audio
{
public:

	Audio();

	// Destructor
	virtual ~Audio();

	bool Load();

	// Called before quitting
	bool CleanUp();

	// Play a music file
	bool PlayMusic(const char* path, float fadeTime = DEFAULT_MUSIC_FADE_TIME);

	// Load a WAV in memory
	unsigned int LoadFx(const char* path);

	// Play a previously loaded WAV
	bool PlayFx(unsigned int fx, int repeat = 0);

	bool Reset();

private:
	SString name;
	_Mix_Music* music;
	List<Mix_Chunk *> fx;
};

#endif // __AUDIO_H__